//+------------------------------------------------------------------+
//|                                                   TEMA Bands.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.ru/ |
//|                                               Written by Linuxser|   
//|                                       http://www.linuxser.com.ar |  
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.ru/"
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 C'249,148,81'
#property indicator_color2 C'249,148,81'

//---- input parameters
extern string abc="-----------Bands Options------------------------";
extern int BandsLength = 20;
extern double BandsDeviation = 2;
extern double BandsShift = 0;
extern string bac="-----------TEMA Options-------------------------";
extern int       EMA_period=20;
//---- buffers
double bup[];
double blow[];
double TemaBuffer[];
double Ema[];
double EmaOfEma[];
double EmaOfEmaOfEma[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,bup);
   SetIndexBuffer(1,blow);   
   SetIndexBuffer(2,TemaBuffer);
   SetIndexBuffer(3,Ema);
   SetIndexBuffer(4,EmaOfEma);
   SetIndexBuffer(5,EmaOfEmaOfEma);
   
   SetIndexLabel(0,"Upper TEMA Band");
   SetIndexLabel(1,"Lower TEMA Band");
   IndicatorShortName("TEMA Bands("+EMA_period+","+BandsLength+")");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i,limit,limit2,limit3,counted_bars=IndicatorCounted();
//----
   if (counted_bars==0)
      {
      limit=Bars-1;
      limit2=limit-EMA_period;
      limit3=limit2-EMA_period;
      }
   if (counted_bars>0)
      {
      limit=Bars-counted_bars-1;
      limit2=limit;
      limit3=limit2;
      }
   for (i=limit;i>=0;i--) Ema[i]=iMA(NULL,0,EMA_period,0,MODE_EMA,PRICE_CLOSE,i);
   for (i=limit2;i>=0;i--) EmaOfEma[i]=iMAOnArray(Ema,0,EMA_period,0,MODE_EMA,i);
   for (i=limit3;i>=0;i--) EmaOfEmaOfEma[i]=iMAOnArray(EmaOfEma,0,EMA_period,0,MODE_EMA,i);
   for (i=limit3;i>=0;i--) TemaBuffer[i]=3*Ema[i]-3*EmaOfEma[i]+EmaOfEmaOfEma[i];
   for (i=limit3;i>=0;i--) bup[i]=iBandsOnArray(TemaBuffer,Bars,BandsLength,BandsDeviation,BandsShift,MODE_UPPER,i);
   for (i=limit3;i>=0;i--) blow[i]=iBandsOnArray(TemaBuffer,Bars,BandsLength,BandsDeviation,BandsShift,MODE_LOWER,i);   
     
//----
   return(0);
  }
//+------------------------------------------------------------------+