//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2
#property indicator_level1  0

//
//
//
//
//

extern int  Length      = 25;
extern int  Price       = PRICE_CLOSE;
extern int  MaMode      = MODE_EMA;
extern bool Directional = false;

double chi[];
double avg[];
double prc[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(3);
         SetIndexBuffer(0,chi);
         SetIndexBuffer(1,avg);
         SetIndexBuffer(2,prc);
   IndicatorShortName("Chi squared ("+Length+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      prc[i] = iMA(NULL,0,1     ,0,MODE_SMA,Price,i);
      avg[i] = iMA(NULL,0,Length,0,MaMode  ,Price,i);
      chi[i] = 0;

      //
      //
      //
      //
      //
      
      for (int k=0; k<Length && avg[i+k]!=0; k++)
      {
         if (Directional)
         {
            if (avg[i+k]>prc[i+k])
                  double sign = -1;
            else         sign =  1;                
            chi[i] += sign*MathPow(prc[i+k]-avg[i+k],2)/avg[i+k];
         }
         else chi[i] += MathPow(prc[i+k]-avg[i+k],2)/avg[i+k];
      }            
   }
   return(0);
}

