#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_style2  STYLE_DOT

extern int FastPeriod  = 10;
extern int FastPrice   = PRICE_CLOSE;
extern int FastMethod  = MODE_EMA;
extern int ProShift    = 2;

double fast[];
double pro[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
      SetIndexBuffer(0,fast);
      SetIndexBuffer(1,pro);
      return(0);  
}  
int deinit() { return(0);  }  

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      fast[i] = iMA(NULL,0,FastPeriod,0,FastMethod ,FastPrice,i);
      pro[i]  = fast[i+ProShift];
   }
   return(0);
}