//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

extern int MaPeriod = 20;
extern int MaPrice  = PRICE_TYPICAL;
extern int MaType   = 4;

//
//
//
//
//

double maBuffer[];
double chgBuffer[];
double prcBuffer[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,maBuffer);
   SetIndexBuffer(1,chgBuffer);
   SetIndexBuffer(2,prcBuffer);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,k,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
      
   for(i=limit; i>=0; i--)
   {
      prcBuffer[i] = iMA(NULL,0,1,0,MODE_SMA,MaPrice,i);
      chgBuffer[i] = MathAbs(prcBuffer[i]-prcBuffer[i+1]);

      //
      //
      //
      //
      //
      
         double sum = 0, suv = 0;
            for (k=0; k<MaPeriod; k++)
            {
               sum += chgBuffer[i+k];
               suv += Volume[i+k];
            }
         double moavg = 0, vwavg = 0, lwavg = iMA(NULL,0,MaPeriod,0,MODE_LWMA,MaPrice,i); 
            for (k=0; k<MaPeriod; k++)
            {
               moavg += prcBuffer[i+k]*chgBuffer[i+k]/sum;
               vwavg += prcBuffer[i+k]*Volume[i+k]   /suv;
            }

      //
      //
      //
      //
      //
      
         switch (MaType)
         {
            case 0:  maBuffer[i] = moavg;             break;
            case 1:  maBuffer[i] = vwavg;             break;
            case 2:  maBuffer[i] = (moavg+vwavg)/2.0; break;
            case 3:  maBuffer[i] = (moavg+lwavg)/2.0; break;
            case 4:  maBuffer[i] = (vwavg+lwavg)/2.0; break;
            default: maBuffer[i] = (moavg+vwavg+lwavg)/3.0;
         }
   }      
   return(0);
}